import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:flutter_progress_hud/flutter_progress_hud.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';
import 'package:intl/intl.dart';
import 'package:unit2/bloc/profile/profile_bloc.dart';
import 'package:unit2/bloc/user/user_bloc.dart';
import 'package:unit2/model/profile/work_history.dart';
import 'package:unit2/theme-data.dart/box_shadow.dart';
import 'package:unit2/theme-data.dart/colors.dart';
import 'package:unit2/utils/text_container.dart';
import 'package:unit2/widgets/Leadings/add_leading.dart';
import 'package:unit2/widgets/empty_data.dart';
import 'package:unit2/widgets/error_state.dart';

import '../../../bloc/profile/workHistory/workHistory_bloc.dart';
import '../../../utils/global.dart';

class WorkHistoryScreen extends StatelessWidget {
  const WorkHistoryScreen({super.key});

  @override
  Widget build(BuildContext context) {
    DateFormat dteFormat2 = DateFormat.yMMMMd('en_US');
    return Scaffold(
        appBar: AppBar(
          title: const Text(workHistoryScreenTitle),
          backgroundColor: primary,
          centerTitle: true,
          actions: [AddLeading(onPressed: () {})],
        ),
        body:
            //UserBloc
            ProgressHUD(
          padding: const EdgeInsets.all(24),
              backgroundColor: Colors.black87,
          indicatorWidget: const SpinKitFadingCircle(
            color: Colors.white,
          ),
          child: BlocBuilder<UserBloc, UserState>(
            builder: (context, state) {
              if (state is UserLoggedIn) {
                return BlocBuilder<ProfileBloc, ProfileState>(
                  builder: (context, state) {
                    //ProfileBloc
                    if (state is ProfileLoaded) {
                      //WorkHistoryBloc
                      return BlocConsumer<WorkHistoryBloc, WorkHistoryState>(
                        listener: (context, state) {
                          if (state is WorkHistoryLoadingState) {
                            final progress = ProgressHUD.of(context);
                            progress!.showWithText("Please wait...");
                          }
                          if (state is WorkHistoryLoaded || state is WorkHistoryErrorState) {
                            final progress = ProgressHUD.of(context);
                            progress!.dismiss();
                          }
                        },
                        builder: (context, state) {
                          if (state is WorkHistoryLoaded) {
                            if (state.workExperiences.isNotEmpty) {
                              return ListView.builder(
                                  padding: const EdgeInsets.symmetric(
                                      vertical: 8, horizontal: 10),
                                  itemCount: state.workExperiences.length,
                                  itemBuilder:
                                      (BuildContext context, int index) {
                                    String position = state
                                        .workExperiences[index]
                                        .position!
                                        .title!;
                                    String agency = state
                                        .workExperiences[index].agency!.name!;
                                    String from = dteFormat2.format(
                                        state.workExperiences[index].fromDate!);
                                    String? to =
                                        state.workExperiences[index].toDate ==
                                                null
                                            ? present.toUpperCase()
                                            : dteFormat2.format(
                                                state.workExperiences[index].toDate!);
                                    return Column(
                                      children: [
                                        Container(
                                          width: screenWidth,
                                          decoration: box1(),
                                          padding: const EdgeInsets.symmetric(
                                              horizontal: 12, vertical: 8),
                                          child: Row(children: [
                                            Expanded(
                                                child: Column(
                                              mainAxisAlignment:
                                                  MainAxisAlignment.start,
                                              crossAxisAlignment:
                                                  CrossAxisAlignment.start,
                                              children: [
                                                Text(
                                                  position,
                                                  style: Theme.of(context)
                                                      .textTheme
                                                      .titleMedium!
                                                      .copyWith(
                                                          fontWeight:
                                                              FontWeight.w600),
                                                ),
                                                const Divider(),
                                                const SizedBox(
                                                  height: 8,
                                                ),
                                                Text(
                                                  agency,
                                                  style: Theme.of(context)
                                                      .textTheme
                                                      .titleSmall!
                                                      .copyWith(
                                                          fontWeight:
                                                              FontWeight.w500),
                                                ),
                                                const SizedBox(
                                                  height: 5,
                                                ),
                                                Text(
                                                  "$from $to ",
                                                  style: Theme.of(context)
                                                      .textTheme
                                                      .bodyMedium,
                                                ),
                                              ],
                                            )),
                                            IconButton(
                                                onPressed: () {},
                                                icon: const Icon(
                                                  Icons.more_vert,
                                                  color: Colors.grey,
                                                ))
                                          ]),
                                        ),
                                        const SizedBox(
                                          height: 5,
                                        ),
                                      ],
                                    );
                                  });
                            } else {
                              return const EmptyData(
                                  message:
                                      "You don't have any work experience added. Please click + to add");
                            }
                          }
                          if (state is WorkHistoryErrorState) {
                            return SomethingWentWrong(
                                message: state.message, onpressed: () {});
                          }
                          return Container();
                        },
                      );
                    }
                    return Container();
                  },
                );
              }
              return Container();
            },
          ),
        ));
  }
}
